;
 .CT
 .LS
 .CE
 .BA $2000
 .MC $A000
 .OS
;
; ZERO PAGE EQUATES
;
BOS .DE $0     ;BOTTOM OF STACK
TOS .DE $9E     ;TOP OF STACK
N .DE TOS+8     ;SCRATCH WORKSPACE
IP .DE N+8;INTERPRETIVE POINTER
W .DE IP+3;CODE FIELD POINTER
UP .DE W+2;USER AREA POINTER
XSAVE .DE UP+2;TEMP. X REG
;
;TERMINAL AND DISC I/O EQUATES
;
TIBX .DE $100;TERMINAL IN BUFFER
;
XMAXSCR .DE 139;139 SCREENS DOS 3.3
SSIZE .DE 256;SECTOR SIZE
NBUF .DE 4;4 * 256 =1024
SECTR .DE 560;SECTORS PER APPLE DRIVE
SECTL .DE 1120;SECTOR LIMIT 2 DRIVES
BMAG .DE 1040;TOTAL BUFFER
MEM .DE $9600;TOP ASSIGNED MEM+1
UAREA .DE MEM-128;USER AREA
DAREA .DE UAREA-BMAG;DISC BUFFER
;
;MONITOR CALLS FOR TERMINAL SUPPORT
;
OUTCH .DE $D00 ;COUT ROUTINE
INCH .DE $D16  ;RDKEY ROUTINE
;
;JMP VECTORS TO BOOTUP CODE AND SYSTEM PARAMETERS
;
ORIG
ENTER LDX #1;COLD START
 JMP COLD+2
REENTR LDX #0;WARM ENTRY POINT
 JMP WARM
;
 .BY $19 $84;YEAR OF RELEASE
XNTOP .SI NTOP;LAST NAME ADDRESS
 .BY $08 00;APPLE BACKSPACE
XUSERS .SI UAREA;INITIAL USER AREA
 .SI TOS+2;INITIAL TOP OF STACK
 .BY $FF $01;INITIAL TOP OF RETURNSTACK
 .SI TIBX;TERM. INPUT BUFFER
 .BY $1F 00;INITIAL FIELD WIDTH, 31
 .BY 00 00 ;0=NO DISC, 1=DISC
 .SI TOP;INITIAL FENCE ADDRESS
 .SI TOP;INITIAL TOP OF DICTIONARY
 .SI VLO;INITIAL VOC-LINK POINTER
;
 BRK;AVOIDS CFA ENDING $XXFF
 BRK
 BRK
 BRK
 BRK
;LIT 13-1
L22 .BY $83 'LI' $D4
 .BY 00 00
LIT .SI =+2
 LDA (IP),Y
 PHA
 INC *IP
 BNE L30
 INC *IP+1
L30 LDA (IP),Y
L31 INC *IP
 BNE PUSH
 INC *IP+1
PUSH DEX
 DEX
PUT STA *1,X
 PLA
 STA *0,X
NEXT LDY #1
 LDA (IP),Y
 STA *W+1
 DEY
 LDA (IP),Y
 STA *W
 CLC
 LDA *IP
 ADC #2
 STA *IP
 BCC L54
 INC *IP+1
L54 JMP W-1
;
L35 .BY $84 'CLI' $D4
 .SI L22
CLIT .SI =+2
 LDA (IP),Y
 PHA
 TYA
 BEQ L31
;
;PRINT CHARACTER IN ACCU AND SAVE X AND Y
;
LETTER PHA
 TYA
 PHA
 TXA
 PHA
 TSX
 LDA $103,X;GET ACCU
 ORA #%10000000 ;SET BIT 7
 AND #%01111111 ;CLEAR BIT 7
 JSR OUTCH
 PLA
 TAX
 PLA
 TAY
 PLA
 RTS
;
XBLANK LDA #$20
 JSR LETTER
 RTS
;
CRLF LDA #$0D
 JSR LETTER
 LDA #$0A
 JSR LETTER
 RTS
;
;PRINT ACCU AS HEX DIGIT
;
HEX2 PHA
 LSR A
 LSR A
 LSR A
 LSR A
 JSR HEXASC
 JSR LETTER
 PLA
 AND #%00001111
 JSR HEXASC
 JSR LETTER
 RTS
;
HEXASC CMP #$A
 BCC Q1
 CLC
 ADC #7
Q1 ADC #'0
 RTS
;
SETUP ASL A
 STA *N-1
L63 LDA *0,X
 STA N,Y
 INX
 INY
 CPY *N-1
 BNE L63
 LDY #0
 RTS
; EXECUTE 14-11 (SCREEN 14 LINE 11)
L75 .BY $87 'EXECUT' $C5
 .SI L35
EXEC .SI =+2
 LDA *0,X
 STA *W
 LDA *1,X
 STA *W+1
 INX
 INX
 JMP W-1
;BRANCH 15-1
L89 .BY $86 'BRANC' $C8
 .SI L75
BRAN .SI =+2
 CLC
 LDA (IP),Y
 ADC *IP
 PHA
 INY
 LDA (IP),Y
 ADC *IP+1
 STA *IP+1
 PLA 
 STA *IP
 JMP NEXT+2
; 0BRANCH 15-6
L107 .BY $87 '0BRANC' $C8
 .SI L89
ZBRAN .SI =+2
 INX
 INX
 LDA *$FE,X
 ORA *$FF,X
 BEQ BRAN+2
BUMP CLC
 LDA *IP
 ADC #2
 STA *IP
 BCC L122
 INC *IP+1
L122 JMP NEXT
; (LOOP) 16-1
L127 .BY $86 '(LOOP' $A9
 .SI L107
PLOOP .SI =+2
L130 STX *XSAVE
 TSX
 INC $101,X
 BNE PL1
 INC $102,X
PL1 CLC
 LDA $103,X
 SBC $101,X
 LDA $104,X
 SBC $102,X
PL2 LDX *XSAVE
 ASL A
 BCC BRAN+2
 PLA
 PLA 
 PLA
 PLA
 JMP BUMP
; (+LOOP) 16-8
L154 .BY $87 '(+LOOP' $A9
 .SI L127
PPLOO .SI =+2
 INX
 INX
 STX *XSAVE
 LDA *$FF,X
 PHA
 PHA
 LDA *$FE,X
 TSX
 INX
 INX
 CLC
 ADC $101,X
 STA $101,X
 PLA
 ADC $102,X
 STA $102,X
 PLA
 BPL PL1
 CLC
 LDA $101,X
 SBC $103,X
 LDA $102,X
 SBC $104,X
 JMP PL2
; (DO) 17-2
L185 .BY $84 '(DO' $A9
 .SI L154
PDO .SI =+2
 LDA *3,X
 PHA
 LDA *2,X
 PHA
 LDA *1,X
 PHA
 LDA *0,X
 PHA
POPTWO INX
 INX
POP INX
 INX
 JMP NEXT
; I 17-9
L207 .BY $81 $C9
 .SI L185
I .SI R+2
; DIGIT 18-1
L214 .BY $85 'DIGI' $D4
 .SI L207
DIGIT .SI =+2
 SEC
 LDA *$2,X
 SBC #$30
 BMI L234
 CMP #$A
 BMI L227
 SEC
 SBC #$7
 CMP #$A
 BMI L234
L227 CMP *$0,X
 BPL L234
 STA *2,X
 LDA #1
 PHA
 TYA
 JMP PUT;EXIT WITH CONVERTED VAL
L234 TYA
 PHA
 INX
 INX
 JMP PUT;EXIT FALSE
; (FIND) 19-1
L243 .BY $86 '(FIND' $A9
 .SI L214
PFIND .SI =+2
 LDA #2
 JSR SETUP
 STX *XSAVE
L249 LDY #0
 LDA (N),Y
 EOR (N+2),Y
 AND #$3F
 BNE L281
L254 INY
 LDA (N),Y
 EOR (N+2),Y
 ASL A
 BNE L280
 BCC L254
 LDX *XSAVE
 DEX
 DEX
 DEX
 DEX
 CLC
 TYA
 ADC #5
 ADC *N
 STA *2,X
 LDY #0
 TYA
 ADC *N+1
 STA *3,X
 STY *1,X
 LDA (N),Y
 STA *0,X
 LDA #1
 PHA
 JMP PUSH
L280 BCS L284
L281 INY
 LDA (N),Y
 BPL L281
L284 INY
 LDA (N),Y
 TAX
 INY
 LDA (N),Y
 STA *N+1
 STX *N
 ORA *N
 BNE L249
 LDX *XSAVE
 LDA #0
 PHA
 JMP PUSH
;ENCLOSE WITH 16 BIT COUNTER
;WRITTEN BY ANDY BIGGS, U.K.
;FORTH DIMENSIONS III/6 P170
L301 .BY $87 'ENCLOS' $C5
 .SI L243
ENCL .SI =+2
 LDA #2
 JSR SETUP
 TXA
 SEC
 SBC #8
 TAX
 STY *3,X
 STY *1,X
; INIT AS BEFORE, ZERO HI INDEX
 DEY
 DEC *N+3
 DEC *1,X
;PRIME THESE VALUES FOR LOOP
L313 INY
 BNE XXX1
 INC *N+3;INC HI ADRES AND
 INC *1,X;HI INDEX
XXX1 LDA (N+2),Y
 CMP *N
 BEQ L313
 STY *4,X
 LDA *1,X
 STA *5,X
L318 LDA (N+2),Y
 BNE L327
 STY *2,X
 STY *0,X
 LDA *1,X
 STA *3,X
 TYA
 CMP *4,X
 BNE L326
 LDA *1,X
 CMP *5,X
 BNE L326
 INC *2,X
 BNE L326
 INC *3,X
L326 JMP NEXT
L327 PHA;SAVE CHARACTER
 STY *2,X
 LDA *1,X;SAVE INDEX AS OFFSET
 STA *3,X
 INY
 BNE XXX5
 INC *1,X
 INC *N+3
XXX5 PLA
 CMP *N
 BNE L318
 STY *0,X
 JMP NEXT
;EMIT 31-5
L337 .BY $84 'EMI' $D4
 .SI L301
EMIT .SI XEMIT;EMIT CODE VECTOR
;KEY 21-7
L344 .BY $83 'KE' $D9
 .SI L337
KEY .SI XKEY;KEY VECTOR
; ?TERMINAL 21-9
L351 .BY $89 '?TERMINA' $CC
 .SI L344
QTERM .SI XQTER
; CR 21-11
L358 .BY $82 'C' $D2
 .SI L351
CR .SI XCR
; CMOVE 22-1
L365 .BY $85 'CMOV' $C5
 .SI L358
CMOVE .SI =+2
 LDA #3
 JSR SETUP
L370 CPY *N
 BNE L375
 DEC *N+1
 BPL L375
 JMP NEXT
L375 LDA (N+4),Y
 STA (N+2),Y
 INY
 BNE L370
 INC *N+5
 INC *N+3
 JMP L370
; U* 23-1
L386 .BY $82 'U' $AA
 .SI L365
USTAR .SI =+2
 LDA *2,X
 STA *N
 STY *2,X
 LDA *3,X
 STA *N+1
 STY *3,X
 LDY #16;FOR 16 BITS
L396 ASL *2,X
 ROL *3,X
 ROL *0,X
 ROL *1,X
 BCC L411
 CLC
 LDA *N
 ADC *2,X
 STA *2,X
 LDA *N+1
 ADC *3,X
 STA *3,X
 LDA #0
 ADC *0,X
 STA *0,X
L411 DEY
 BNE L396
 JMP NEXT
; U/ 23-1
;SEE FORTH DIMENSIONS IV/2. P 30
L418 .BY $82 'U' $AF
 .SI L386
USLAS .SI =+2
 STY *N+1;ADDITIONAL
 LDA *4,X
 LDY *2,X
 STY *4,X
 ASL A
 STA *2,X
 LDA *5,X
 LDY *3,X
 STY *5,X
 ROL A
 STA *3,X
 LDA #16
 STA *N
L433 ROL *4,X
 ROL *5,X
 ROL *N+1;ADDITIONAL
 SEC
 LDA *4,X
 SBC *0,X
 TAY
 LDA *5,X
 SBC *1,X
 PHA
 LDA *N+1
 SBC #0
 PLA
 BCC L444
 STY *4,X
 STA *5,X
L444 ROL *2,X
 ROL *3,X
 DEC *N
 BNE L433
 JMP POP
; AND 25-2
L453 .BY $83 'AN' $C4
 .SI L418
ANDD .SI =+2
 LDA *0,X
 AND *2,X
 PHA
 LDA *1,X
 AND *3,X
 INX
 INX
 JMP PUT
;OR 25-7
L469 .BY $82 'O' $D2
 .SI L453
OR .SI =+2
 LDA *0,X
 ORA *2,X
 PHA
 LDA *1,X
 ORA *3,X
 INX
 INX
 JMP PUT
;XOR 25-11
L484 .BY $83 'XO' $D2
 .SI L469
XOR .SI =+2
 LDA *0,X
 EOR *2,X
 PHA
 LDA *1,X
 EOR *3,X
 INX
 INX
 JMP PUT
; SP@ 26-1
L499 .BY $83 'SP' $C0
 .SI L484
SPAT .SI =+2
 TXA
PUSH0A PHA
 LDA #0
 JMP PUSH
; SP! 26-5
L511 .BY $83 'SP' $A1
 .SI L499
SPSTO .SI =+2
 LDY #6
 LDA (UP),Y;GET DATASTACK POINTER
 TAX
 JMP NEXT
;RP! 26-8
L522 .BY $83 'RP' $A1
 .SI L511
RPSTO .SI =+2
 STX *XSAVE
 LDY #8
 LDA (UP),Y
 TAX
 TXS
 LDX *XSAVE
 JMP NEXT
; ;S 26-2
L536 .BY $82 ';' $D3
 .SI L522
SEMIS .SI =+2
 PLA
 STA *IP
 PLA
 STA *IP+1
 JMP NEXT
; LEAVE 27-1
L548 .BY $85 'LEAV' $C5
 .SI L536
LEAVE .SI =+2
 STX *XSAVE
 TSX
 LDA $101,X
 STA $103,X
 LDA $102,X
 STA $104,X
 LDX *XSAVE
 JMP NEXT
; >R 27-5
L563 .BY $82 '>' $D2
 .SI L548
TOR .SI =+2
 LDA *1,X
 PHA
 LDA *0,X
 PHA
 INX
 INX
 JMP NEXT
; R> 27-8
L577 .BY $82 'R' $BE
 .SI L563
RFROM .SI =+2
 DEX
 DEX
 PLA
 STA *0,X
 PLA
 STA *1,X
 JMP NEXT
; R 27-11
L591 .BY $81 $D2
 .SI L577
R .SI =+2
 STX *XSAVE
 TSX
 LDA $101,X
 PHA
 LDA $102,X
 LDX *XSAVE
 JMP PUSH
; 0= 28-2
L605 .BY $82 '0' $BD
 .SI L591
ZEQU .SI =+2
 LDA *0,X
 ORA *1,X
 STY *1,X
 BNE L613
 INY
L613 STY *0,X
 JMP NEXT
; 0< 28-6
L619 .BY $82 '0' $BC
 .SI L605
ZLESS .SI =+2
 ASL *1,X
 TYA
 ROL A
 STY *1,X
 STA *0,X
 JMP NEXT
; + 
L632 .BY $81 $AB
 .SI L619
PLUS .SI =+2
 CLC
 LDA *0,X
 ADC *2,X
 STA *2,X
 LDA *1,X
 ADC *3,X
 STA *3,X
 INX
 INX
 JMP NEXT
; D+
L649 .BY $82 'D' $AB
 .SI L632
DPLUS .SI =+2
 CLC
 LDA *2,X
 ADC *6,X
 STA *6,X
 LDA *3,X
 ADC *7,X
 STA *7,X
 LDA *0,X
 ADC *4,X
 STA *4,X
 LDA *1,X
 ADC *5,X
 STA *5,X
 JMP POPTWO
;
; - END PART 1 --
